use std::collections::HashMap;
use std::fs;
use winnow::Parser;
use winnow::Result;
use yaml_rust2::{Yaml, YamlEmitter, YamlLoader};
enum PyffrVerb {
    //    dump,
    //    map,
    Then,
    //    log_entity,
    //    print,
    //    end,
    //    fork,
    //    break,
    //    pipe,
    When,
    //    info,
    //    sort,
    //    publish,
    //    load,
    //    select,
    //    filter,
    //    pick,
    //    first,
    //    discojson,
    //    discojson_sp,
    //    discojson_sp_attr,
    //    sign,
    //    stats,
    //    summary,
    //    store,
    //    xslt,
    //    indent,
    //    validate,
    //    prune,
    //    check_xml_namespaces,
    //    drop_xsi_type,
    //    certreport,
    //    emit,
    //    signcerts,
    //    finalize,
    //    reginfo,
    //    pubinfo,
    //    setattr,
    //    nodecountry
}
struct Pipeline {
    verb: String,
    args: Yaml,
}

//
//}
//pub fn parse_pyff(input: &Yaml) -> &str {
//    let docs = YamlLoader::load_from_str(fs::read_to_string("pyff.fd").unwrap().as_str()).unwrap();
//    let mut out_str = String::new();
//    let mut emitter = YamlEmitter::new(&mut out_str);
//    let doc = &docs[0];
//    emitter.dump(&doc[0]).unwrap();
//    dbg!(out_str);
//    return "ok";
//}

//[cfg(test)]
//mod tests {
//    use super::*;
//
//[test]
//    fn test_pyff_parse() {
//        let docs = YamlLoader::load_from_str("[when, 2, 3]").unwrap();
//        let result = parse_pyff("asd");
//        assert_eq!(result, "asd");
//    }
//}

fn when_fn(args: &Yaml) {
    println!("{:?}\n\n\n", args);
}

fn parse(input: &Yaml, pipelines: Option<Vec<Pipeline>>) -> Vec<Pipeline> {
    let mut tmp: Vec<Pipeline> = pipelines.unwrap_or(Vec::new());
    for pipeline in input.as_vec().unwrap() {
        if pipeline.is_array() {
            println!("Is Array");
        }
        if pipeline.is_hash() {
            println!("Is Array");
        }
        for key in pipeline.as_hash().unwrap().keys() {
            let _key = key
                .as_str()
                .unwrap()
                .split_ascii_whitespace()
                .nth(0)
                .unwrap();
            println!("{:?}", key);
            println!("{:?}", pipeline.as_hash().unwrap()[key].clone());
            match _key {
                _ => tmp.push(Pipeline {
                    verb: _key.to_string(),
                    args: pipeline.as_hash().unwrap()[key].clone(), // TODO check is_string ->
                                                                    // recurse
                }),
            }
        }
    }
    return tmp;
}

fn main() {
    let docs = YamlLoader::load_from_str(fs::read_to_string("pyff.fd").unwrap().as_str()).unwrap();
    let doc = &docs[0];
    let pipelines = parse(doc, None);
    for pipeline in pipelines {
        println!("main: {:?}", pipeline.args.as_hash().unwrap().keys());
        for key in pipeline.args.as_hash().unwrap().keys() {
            match key
                .as_str()
                .unwrap()
                .split_ascii_whitespace()
                .nth(0)
                .unwrap()
            {
                "when" => when_fn(&pipeline.args),
                _ => println!("Unimplemented: {:?}", key),
            }
        }
    }

    //    println!("{:?}", doc);
}
